#!/usr/bin/python
# Nom de fichier : jiminy.py

import os,threading,time,liblo,subprocess
from pyproj import Proj
from parallele import *
from varglob import *
from bddrequetes import *
from mod_AdaLED import LEDBackpack
from mod_Ada8x8 import *

class Jiminy():
    zone= ''
    vaccin=[]
     
    def __init__ (self):
	print "Lancement du jeu"
	fichier_son = Glob.chemin+'lancement.wav'
   	self.grid = ColorEightByEight(address=0x74) # matrice sur 0x74
	Glob.couleur = 'bleu'
	subprocess.call(['aplay','-Dplug:dmixer',fichier_son])

    def __del__ (self):
	print 'Fin du jeu'
 
    def danszone(self,bd,gps):
    # Retourne la zone ou est le joueur
	requete=''
	try:
	    lat_courant = gps.get_current_value()['lat']
	    long_courant = gps.get_current_value()['lon']
	    p = Proj(proj='utm',zone=30,ellps='WGS84') # pour l'ouest de la France, zone UTM30 Nord
	    x,y = p(long_courant,lat_courant)
	except:
	    # pb recup GPS ou projection
	    return False
	try:
	    requete = "SELECT id_evt FROM evenements WHERE POW(%f-x_utm,2) + POW(%f-y_utm,2) < POW(zone,2)"%(x,y)
	    if bd.executerReq(requete):
		resultats = bd.resultatReq()
		if resultats == []:
		    resultat = False
		else:
		    resultat = resultats[0][0]
	    else:
		resultat = False
	except:
	    # pb requete danszone
	    return False

	return resultat
 
    def danszonetampon(self,bd,gps,zone):
    # Verification si on est dans une zone tampon (5m)
	requete = "SELECT zone FROM evenements WHERE id_evt='%s'"%zone
	try:
	    if bd.executerReq(requete):
		resultats = bd.resultatReq()
		if resultats == []:
		    resultat = False
		else:
		    resultat = resultats[0][0]
	    else:
		return False
	except:
	    # pb requete zone tampon
	    return False
	try:
	    rayon=int(resultat)+5
	    lat_courant = gps.get_current_value()['lat']
	    long_courant = gps.get_current_value()['lon']
	    p = Proj(proj='utm',zone=30,ellps='WGS84') # pour l'ouest de la France, zone UTM30 Nord
	    x,y = p(long_courant,lat_courant)
	except:
	    # pb GPS ou proj danszonetampon'
	    return False
	try:
	    requete == "SELECT id_evt FROM evenements WHERE POW(%f-x_utm,2) + POW(%f-y_utm,2) < POW(zone,2)"%(x,y)
	    if bd.executerReq(requete):
		resultats = bd.resultatReq()
		if resultats == []:
		    resultat = False
		else:
		    resultat = resultats[0][0]
	    else:
		resultat = False
	except:
	    # pb requete evt danszonetampon
	    return False

	return resultat
