#!/usr/bin/python
# Nom de fichier : parallele.py
 
import time,os,gps,sys,threading,commands,serial
from varglob import *
from bddrequetes import *
from quick2wire.gpio import pins, In, Out
from mod_AdaLED import LEDBackpack
from mod_Ada8x8 import *
from smbus import SMBus

class Litgps(threading.Thread):
# Recupere les donnees du GPS dans un thread
    cpt_verif = 0

    def __init__ (self):
	self.session = gps.gps(mode=gps.WATCH_ENABLE) # gpsd par defaut sur le port 2947
	self.current_value = None
        threading.Thread.__init__(self)
	self.Termine=False

    def __del__ (self):
	self.Termine=True

    def run(self):
	while not self.Termine:
    	    try:
	    	self.current_value = self.session.next()
    	    except StopIteration:
            	pass

    def stop(self):
	self.Termine=True

    def get_current_value(self):
	#lat, lon avec une precision superieure a 15
	while self.current_value['epx'] > 20 and self.current_value['epy'] > 20:
	    self.current_value=self.session.next()

	return self.current_value

class LitRFID(threading.Thread):
# lit les 5 boutons tactiles
    val_RFID=0

    def __init__(self):
    	self.ser = serial.Serial('/dev/ttyAMA0')
        threading.Thread.__init__(self)
	self.TermineRFID = False

    def __del__(self):
	self.ser.close()
	self.TermineRFID = True

    def run(self):
	while not self.TermineRFID:
	    try:
	    	self.val_RFID = self.ser.read(14)[:13]
	    except serial.serialutil.SerialException:
		continue
	    except:
		continue

    def stop(self):
	self.ser.close()
	self.TermineRFID = True

    def activeRFID(self):
	retour = False
	if self.val_RFID > 0:
	    retour = True
	return retour

class Ecrit_matrice(threading.Thread):

    def __init__(self,jim_jou):
        threading.Thread.__init__(self)
	self.TermineMatrice = False
	self.jim_jou = jim_jou

    def __del__(self):
	self.TermineMatrice = True

    def run(self):
	while not self.TermineMatrice:
	    if Glob.nb_coul > 0:
		self.cpt_couleur(Glob.coul_cpt,self.jim_jou)
	    pass

    def stop(self):
	self.TermineMatrice = True

    def cpt_couleur(self,couleur,jim_jou):
	if couleur == 'bleu': id_coul = 1 # jaune
	elif couleur == 'vert': id_coul = 2 # rouge
	elif couleur == 'rouge': id_coul = 3  # orange

	for x in range(0, 8,Glob.nb_coul):
	  for y in range(0, 8):
	    jim_jou.grid.setPixel(x, y, id_coul) #recup le grid de jim_jou
	    time.sleep(0.5)

	if Glob.nb_coul == 3:
	   print "fin du jeu"

	#jim_jou.self.grid.clear() #grid de jim_jou ?
	self.TermineMatrice = False
