#!/usr/bin/python
# coding=utf-8
# nom de fichier : fct_div.py

from bddrequetes import *
from varglob import *

### Menu de depart
def menu(bd):
    while 1:
	print("\nVoulez-vous :\n\t1) Creer les tables de la base de donnees\n\t2) Supprimer les tables\n\t3) Afficher une table\n\t4) Entrer un enregistrement\n\t5) Modifier un enregistrement\n\t6) Lancer le jeu\n\t7) Terminer\nVotre choix : ")
	ch= int(raw_input())
	if ch == 1:
	    bd.creerTables(Glob.dicoT)
	elif ch == 2:
	    bd.supprimerTables(Glob.dicoT)
        elif ch == 3:
	    enreg=Enregistreur(bd,'evenements')
	    enreg.afficher()
	elif ch == 4:
	    enreg=Enregistreur(bd,'evenements')
	    while 1:
		if enreg.entrer():
		    break
        elif ch == 5:
	    enreg=Enregistreur(bd,'evenements')
	    enreg.modifier()
	elif ch == 6:
	    bd.commit()
	    break
	else:
	    bd.commit()
	    bd.close()
	    sys.exit()

    return bd

### Affichage matrice
def croix_jaune(grid):
	grid.setPixel(0,0,1)
	grid.setPixel(1,1,1)
	grid.setPixel(2,2,1)
	grid.setPixel(3,3,1)
	grid.setPixel(4,4,1)
	grid.setPixel(5,5,1)
	grid.setPixel(6,6,1)
	grid.setPixel(7,7,1)

	grid.setPixel(0,7,1)
	grid.setPixel(1,6,1)
	grid.setPixel(2,5,1)
	grid.setPixel(3,4,1)
	grid.setPixel(4,3,1)
	grid.setPixel(5,2,1)
	grid.setPixel(6,1,1)
	grid.setPixel(7,0,1)

def croix_rouge(grid):
	grid.setPixel(0,0,2)
	grid.setPixel(1,1,2)
	grid.setPixel(2,2,2)
	grid.setPixel(3,3,2)
	grid.setPixel(4,4,2)
	grid.setPixel(5,5,2)
	grid.setPixel(6,6,2)
	grid.setPixel(7,7,2)

	grid.setPixel(0,7,2)
	grid.setPixel(1,6,2)
	grid.setPixel(2,5,2)
	grid.setPixel(3,4,2)
	grid.setPixel(4,3,2)
	grid.setPixel(5,2,2)
	grid.setPixel(6,1,2)
	grid.setPixel(7,0,2)

def croix_orange(grid):
	grid.setPixel(0,0,3)
	grid.setPixel(1,1,3)
	grid.setPixel(2,2,3)
	grid.setPixel(3,3,3)
	grid.setPixel(4,4,3)
	grid.setPixel(5,5,3)
	grid.setPixel(6,6,3)
	grid.setPixel(7,7,3)

	grid.setPixel(0,7,3)
	grid.setPixel(1,6,3)
	grid.setPixel(2,5,3)
	grid.setPixel(3,4,3)
	grid.setPixel(4,3,3)
	grid.setPixel(5,2,3)
	grid.setPixel(6,1,3)
	grid.setPixel(7,0,3)

def un(grid):
	grid.setPixel(3,5,1)
	grid.setPixel(2,4,1)
	grid.setPixel(1,3,1)
	grid.setPixel(2,3,1)
	grid.setPixel(3,3,1)
	grid.setPixel(4,3,1)
	grid.setPixel(5,3,1)
	grid.setPixel(6,3,1)
	grid.setPixel(6,2,1)
	grid.setPixel(6,4,1)


def deux(grid):
	grid.setPixel(2,6,3)
	grid.setPixel(1,5,3)
	grid.setPixel(0,3,3)
	grid.setPixel(0,4,3)
	grid.setPixel(2,1,3)
	grid.setPixel(1,2,3)

	grid.setPixel(3,5,3)
	grid.setPixel(4,4,3)
	grid.setPixel(5,3,3)
	grid.setPixel(6,2,3)
	grid.setPixel(6,3,3)
	grid.setPixel(6,4,3)
	grid.setPixel(6,5,3)
	grid.setPixel(6,6,3)

def trois(grid):
	grid.setPixel(2,1,2)
	grid.setPixel(1,2,2)
	grid.setPixel(0,3,2)
	grid.setPixel(0,4,2)
	grid.setPixel(1,5,2)
	grid.setPixel(2,6,2)
	grid.setPixel(3,5,2)
	grid.setPixel(4,6,2)
	grid.setPixel(5,6,2)
	grid.setPixel(6,5,2)
	grid.setPixel(6,4,2)

def sourire(grid):
	grid.setPixel(5,0,3)
	grid.setPixel(4,0,3)
	grid.setPixel(3,0,3)
	grid.setPixel(2,0,3)
	grid.setPixel(1,1,3)
	grid.setPixel(0,2,3)
	grid.setPixel(0,3,3)
	grid.setPixel(0,4,3)
	grid.setPixel(0,5,3)
	grid.setPixel(1,6,3)
	grid.setPixel(2,7,3)
	grid.setPixel(3,7,3)
	grid.setPixel(4,7,3)
	grid.setPixel(5,7,3)
	grid.setPixel(6,6,3)
	grid.setPixel(7,5,3)
	grid.setPixel(7,4,3)
	grid.setPixel(7,3,3)
	grid.setPixel(7,2,3)
	grid.setPixel(6,1,3)
	grid.setPixel(2,2,1)
	grid.setPixel(5,2,1)
	grid.setPixel(2,4,1)
	grid.setPixel(5,4,1)
	grid.setPixel(3,5,1)
	grid.setPixel(4,5,1)

### Divers

def action(bd,jim_jou,matrice):
# Execute l action
    try:
	le_type_evt = bd.type_evt(jim_jou.zone) 
	if le_type_evt == 'objet':
	    fichier_action = Glob.chemin + bd.nom_action(evt)
	    subprocess.call(['sh',fichier_action])
	elif le_type_evt == 'couleur':
	    # verifier si vaccine
	    if bd.nom_action(jim_jou.zone) not in jim_jou.vaccin:
		Glob.coul_cpt = bd.nom_action(jim_jou.zone)
		Glob.nb_coul +=1

	Glob.actions_encours.append(jim_jou.zone)
    except:
	# pb dans l'execution de l'action
	return
