#!/usr/bin/python
# coding=utf-8
#nom de fichier : periph.py

import subprocess
from bddrequetes import *
from varglob import *
from jiminy import *
from fct_div import *

def action_tactile(touchData,grid):
	for i in range(5):
		if (touchData & (1<<i)):
		    if (Glob.touches[i] == 0):
			print( 'Pin ' + str(i) + ' touchee')
			if (i == 0):
			    try:
			    	un(grid)
			    except:
				print 'touche 1'
			    fichier_son = Glob.chemin+'sifflet.wav'
		    	    subprocess.call(['aplay','-Dplug:dmixer',fichier_son])
			elif (i == 1):
			    try:
			    	deux(grid)
			    except:
				print 'touche2'
			    fichier_son = Glob.chemin+'lesconscaosetout.wav'
		    	    subprocess.call(['aplay','-Dplug:dmixer',fichier_son])
			elif (i == 2):
			    try:
			    	trois(grid)
			    except:
				print 'touche 3'
			    fichier_son = Glob.chemin+'loin.wav'
		    	    subprocess.call(['aplay','-Dplug:dmixer',fichier_son])
			elif (i == 3):
			    try:
			    	croix_rouge(grid)
			    except:
				print 'touche 4'
			    fichier_son = Glob.chemin+'orbite.wav'
		    	    subprocess.call(['aplay','-Dplug:dmixer',fichier_son])
			elif (i == 4):
			    try:
			    	croix_jaune(grid)
			    except:
				print 'touche 5'
			    fichier_son = Glob.chemin+'mer.wav'
		    	    subprocess.call(['aplay','-Dplug:dmixer',fichier_son])
		    Glob.touches[i] = 1;
	 	else:
		    if (Glob.touches[i] == 1):
			print( 'Pin ' + str(i) + ' relachee')
			Glob.touches[i] = 0;

def action_gps(bd,jim_jou,gps,matrice):
	jim_jou.zone = jim_jou.danszone(bd,gps) # retourne le nom de la zone
	if not(jim_jou.zone):
	    return

	if jim_jou.zone != False:
	# SI on est dans une zone, 
	    if jim_jou.zone not in Glob.actions_encours:
	    # SI l'evenement n'a pas ete lance ALORS on le lance
		action(bd,jim_jou,matrice)
		Glob.dern_zone = jim_jou.zone

	elif not(jim_jou.danszonetampon(bd,gps,Glob.dern_zone)):
	# SINON SI on est sorti de la zone tampon
	    if Glob.dern_zone in Glob.actions_encours and gps.cpt_verif > 5:
	    # SI l'evenement est actif (=sortie de zone) ALORS on le supprime des actions en cours
		Glob.actions_encours.remove(Glob.dern_zone)
		gps.cpt_verif = 0
		# SI c'est une couleur ALORS on decremente le nb de couleur
		if bd.type_evt(Glob.dern_zone) == 'couleur':
		    Glob.nb_coul -=1

	    elif Glob.dern_zone in Glob.actions_encours:	# compteur pour etre sur qu'on est sorti
		gps.cpt_verif = gps.cpt_verif + 1

def action_rfid(jim_jou,lect_RFID):
	print 'RFID',lect_RFID.val_RFID
	sourire(jim_jou.grid)
	jim_jou.vaccin.append('vert')
	lect_RFID.val_RFID = 0
